#pragma once
#include <stddef.h>

#define SYSCALL_MMAP 9
#define SYSCALL_BRK 12
#define SYSCALL_IOCTL 16
#define SYSCALL_WRITEV 20
#define SYSCALL_SCHED_YIELD 24

typedef long (*syscall_handler)(long, long, long, long, long, long);

// lib/musl-glue.c
syscall_handler set_syscall_handler(long num, syscall_handler handler);
void musl_init();

// drivers/terminal/terminal.c
long k_ioctl(long fd, long cmd, long arg3, long, long, long);
long k_writev(long fd, long iov, long iovcnt, long, long, long);

// memory/kbrk.c
long k_brk(long brk, long, long, long, long, long);
long k_mmap(long addr, long length, long prot, long flags, long fd, long offset);

// proc/scheduler.c
long k_sched_yield(long, long, long, long, long, long);


struct __locale_struct {
  const struct __locale_map *cat[6];
};
struct tls_module {
  struct tls_module *next;
  void *image;
  size_t len, size, align, offset;
};
struct __libc {
  char can_do_threads;
  char threaded;
  char secure;
  volatile signed char need_locks;
  int threads_minus_1;
  size_t *auxv;
  struct tls_module *tls_head;
  size_t tls_size, tls_align, tls_cnt;
  size_t page_size;
  struct __locale_struct global_locale;
};
extern struct __libc __libc;